<template>
  <div>
    <!-- 调度开关 -->
    <p-card title="调度开关">
      <span slot="extra">
        <p-button type="primary" style="margin-right:10px" @click="showmodel()">添加</p-button>
      </span>
      <p-grid-form :label-col="{ span: 8 }" :span="8" :items="config.items" @submit="hanlderSubmit" />
      <p-table
        ref="table"
        row-key="id"
        bordered
        :columns="config.columns"
        :remoteUrl="config.remoteUrl"
        :remoteParams="remoteParams"
        :doneBefore="doneBefore"
        :rowSelectType="false"
        :data-source="data"
        :scroll="{ x: 1500 }"
      >
        <template slot="switchValue" slot-scope="text, record">
          <!-- {{ text ? '禁用' : '启用' }} -->
          <!-- {{ text.switchValue }} -->
          <!-- <a @click="carryinterfacetask(record)">取消任务</a> -->

          <p-switch
            checked-children="开"
            un-checked-children="关"
            v-model="text.switchValuebool"
            @change="(checked, event) => changeswitch(checked, text, record)"
          />
        </template>
      </p-table>
    </p-card>

    <p-modal
      title="详情"
      width="50%"
      :visible="visible"
      :confirm-loading="confirmLoading"
      @ok="handleOk"
      @cancel="handleCancel"
    >
      <p-grid-form :label-col="{ span: 8 }" ref="model" :span="8" :items="config.Modelitems" @submit="hanlderSubmit" />
    </p-modal>
  </div>
</template>

<script>
import config from './config.js'

import { add, stationdelete, stationupdate, dispatchswitch } from './api'

export default {
  data() {
    return {
      config,
      data: [],
      type: true,
      remoteParams: {
        switchCode: '',
        switchName: ''
      },
      visible: false,
      confirmLoading: false
    }
  },
  mounted() {
    // this.getinfo()
    // taskId
  },
  methods: {
    //改变开关
    async changeswitch(checked, text, record) {
      checked ? (text.switchValue = 1) : (text.switchValue = 0)
      console.log(checked, text)
      let res = await dispatchswitch(text)
      console.log(res)
      if (res.success) {
        this.remoteParams = { ...this.remoteParams }
      } else {
        this.$exception(res)
      }
    },
    //取消调度任务
    async carryinterfacetask(record) {
      console.log(record)
      let res = await carrytask({ id: record.id })
      console.log(res)
      if (res.success) {
        this.$message.success('取消任务成功!')
        this.remoteParams = { ...this.remoteParams }
      } else {
        this.$exception(res)
      }
    },
    doneBefore(res) {
      res.data.list.forEach(item => {
        item.switchValuebool = item.switchValue ? true : false
        item.id = item.switchCode
      })
      console.log(res)
      return res
    },
    hanlderSubmit(e, form) {
      e.preventDefault()
      form.validateFields((error, values) => {
        console.log(error, values, 'valuesvaluesvaluesvaluesvalues')
        // this.queryName = values.name
        // this.queryType = values.type
        // this.getlistCompanyByAuthId()
        if (!error) {
          this.remoteParams = { ...this.remoteParams, ...values }
        }
      })
    },
    handleOk(e) {
      this.$refs.model.form.validateFields(async (err, value) => {
        if (!err) {
          console.log(value)
          this.confirmLoading = true
          if (this.type) {
            let res = await stationupdate(value)
            console.log(res)
            if (res.success) {
              this.visible = false
              this.remoteParams = { ...this.remoteParams }
            } else {
              this.$exception(res)
            }
          } else {
            let res = await add(value)
            console.log(res)
            if (res.success) {
              this.visible = false
              this.remoteParams = { ...this.remoteParams }
            } else {
              this.$exception(res)
            }
          }

          this.confirmLoading = false
          //
        }
      })
    },
    handleCancel(e) {
      console.log('Clicked cancel button')
      this.visible = false
    },
    //点击弹出
    showmodel(data) {
      console.log(data)
      this.visible = true

      if (data) {
        this.$nextTick(() => {
          this.$refs.model.form.setFieldsValue(data)
          this.$refs.model.form.setFieldsValue(data)
        })
        this.type = true
      } else {
        this.$nextTick(() => {
          this.$refs.model.form.resetFields()
        })
        this.type = false
      }
    },
    del(text) {
      let that = this
      console.log(text)
      this.$confirm({
        title: '确定是否要删除?',
        content: '',
        async onOk() {
          let res = await stationdelete({ id: text.id })
          if (res.success) {
            that.$message.success('删除成功')
            that.remoteParams = { ...that.remoteParams }
          } else {
            that.$exception(res)
          }
        },
        onCancel() {}
      })
    }
  }
}
</script>

<style lang="less" scoped></style>
